#include <atomic>
#include <iomanip>
#include <iostream>
#include <string>
#include <thread>

int main()
{
  std::cout << "Beenden mit der Entertaste" << std::endl;
  // Möglichst viele Nachkommastellen ausgeben:
  std::cout << std::setprecision(15);

  // Zwei atomare Variablen zum Steuern des Threads
  std::atomic<bool> active = true;
  std::atomic<double> result = 0;

  std::thread leibniz([&]() {
    // Diese Implementierung nutzt die Leibnitz-Formel
    double sign = 1;  // Vorzeichen (+1 oder -1)
    double pi = 0;
    double denominator = 1;
    while (active)
    {
      pi = pi + sign * (4 / denominator);
      // Vorzeichen umdrehen
      sign = -sign;
      // Teiler um zwei erhöhen
      denominator += 2;
      std::cout << "\rStatus (" << denominator << "): " << pi;
    }
    // Ergebnis in der atomaren Variable speichern
    result = pi;
  });

  // Im Haupt-Thread derweil auf die Entertaste warten
  std::string tmp;
  std::getline(std::cin, tmp);
  // Enter wurde gedrückt. Nun den Thread herunterfahren
  active = false;
  leibniz.join();
  std::cout << "\rEndresultat: " << result << std::endl;
  return 0;
}
